// **************************************************************************************
// *
// * © 2012 Dell, Inc.
// * ALL RIGHTS RESERVED.
// *
// * Redistribution and use in source and binary forms, with or without modification, 
// * are permitted provided that the following conditions are met:
// * 
// *  *  Redistributions of source code must retain the above copyright notice, 
// *     this list of conditions and the following disclaimer.  
// * 
// *  *  Redistributions in binary form must reproduce the above copyright notice, 
// *     this list of conditions and the following disclaimer in the documentation 
// *     and/or other materials provided with the distribution.  
// * 
// *  *  Neither the name of Dell, Inc. nor the names of its contributors 
// *     may be used to endorse or promote products derived from this software 
// *     without specific prior written permission. 
// * 
// * 
// * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
// * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
// * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
// * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
// * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
// * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
// * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
// * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// * 
// **************************************************************************************

#include "farmmenudialog.h"
#include "ui_farmmenudialog.h"

FarmMenuDialog::FarmMenuDialog(QWidget *parent) :
    CommonDialog(parent),
    ui(new Ui::FarmMenuDialog)
{
    ui->setupUi(this);

    QPoint pos;
    QPushButton * pb;
    QHBoxLayout hl;

    syslog( LOG_INFO, "Opening VwMenu");

    // Set the correct location,
    pos = QCursor::pos();
    move( pos );
    setModal( true );

    ui->setupUi(this);

    //

    // Lets see what happens with a frame
    QFrame * frame1 = new QFrame;
    QHBoxLayout * frame1Layout = new QHBoxLayout;
    frame1Layout->setSpacing( 0 );
    frame1Layout->setContentsMargins( 0, 0, 0, 0 );
    frame1->setObjectName( tr("Frame1"));
    frame1Layout->setObjectName( tr("Frame's Layout"));

    // Make the Farm button
    pb = new QPushButton( "Test" );
    pb->setObjectName( "Test" );
    pb->setStyleSheet( QString(
           "QPushButton {"
           "text-align: left;}"
           ));
    frame1Layout->addWidget( pb );
    connect( pb, SIGNAL(clicked( bool )), this, SLOT( handleFarmMenuClick( bool )));

    // Make the settings button
    pb = new QPushButton(QIcon(":/img/provision_icon.png"),tr(""));
    pb->setObjectName( "Test" );
    pb->setStyleSheet( QString(
           "QPushButton {"
           "max-width: 30px;"
           "min-width: 29px;"
           "text-align: center;}"
           ));
    frame1Layout->addWidget( pb );
    frame1->setLayout( frame1Layout );
    connect( pb, SIGNAL(clicked( bool )), this, SLOT( handleFarmMenuSettingsClick( bool )));


    ui->verticalLayout->addWidget( frame1, 1, Qt::AlignHCenter );


    // Add the 3 layout boxes.



    setWindowTitle( tr("Testing"));

    setWindowMask( "", ui->frame->width(), ui->frame->height());

}

FarmMenuDialog::~FarmMenuDialog()
{
    delete ui;
}

void FarmMenuDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}
