// **************************************************************************************
// *
// * © 2012 Dell, Inc.
// * ALL RIGHTS RESERVED.
// *
// * Redistribution and use in source and binary forms, with or without modification, 
// * are permitted provided that the following conditions are met:
// * 
// *  *  Redistributions of source code must retain the above copyright notice, 
// *     this list of conditions and the following disclaimer.  
// * 
// *  *  Redistributions in binary form must reproduce the above copyright notice, 
// *     this list of conditions and the following disclaimer in the documentation 
// *     and/or other materials provided with the distribution.  
// * 
// *  *  Neither the name of Dell, Inc. nor the names of its contributors 
// *     may be used to endorse or promote products derived from this software 
// *     without specific prior written permission. 
// * 
// * 
// * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ON AN "AS IS" 
// * AND UNSUPPORTED BASIS, WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES OF ANY KIND, 
// * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-
// * INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL THE COPYRIGHT 
// * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
// * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
// * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
// * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
// * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
// * 
// **************************************************************************************

#include "ports.h"

char* getPrefix(const char* FileName)
{
    if (FileName == NULL)
	return NULL;
    FILE* file;
    char* result = NULL;
    char buf[1024], label[1024], prefix[1024];
    file = fopen(FileName, "r");
    if (file == NULL)
	return NULL;
    while (fgets(buf, 1024, file) > 0){
	if (strlen(buf) < 7)
	    continue;
	if (strstr(buf, "serial")){
	    sscanf(buf, "%s %s", label, prefix);
	    char *tmp;
	    tmp = prefix;
	    while (strstr(tmp, "/")){
		tmp = strstr(tmp, "/");
		tmp++;
	    }
	    result = new char[strlen(tmp) + 1];
	    strcpy(result, tmp);
	}
    }
    return result;
}

QStringList findTtyS(const char* findDir, const char* prefix)
{
    QStringList portNames;
	DIR *dir;
    int count = 0;
    struct dirent *infoDir;
    struct stat infoFile;
    char FileName [1024];
    dir = opendir(findDir);
    if (dir == NULL)
    	return portNames;
    infoDir = readdir(dir);
    while (infoDir  = readdir(dir)/*!= NULL*/)
    {
    	if (infoDir == NULL)
    		break;
    	if (strlen(infoDir->d_name) < strlen(prefix))
    		continue;
    	if (!strcmp (infoDir->d_name, ".")|| !strcmp(infoDir->d_name, ".."))
    		continue;
    	if (strstr(infoDir->d_name, prefix) != infoDir->d_name)
    		continue;
    	strcpy(FileName, findDir);
    	strcat(FileName, "/");
    	strcat(FileName, infoDir->d_name);
    	stat(FileName, &infoFile);
    	if (S_ISDIR(infoFile.st_mode))
    		continue;
    	count++;
    	char *result = new char[strlen(FileName) + 1];
    	strcpy(result, FileName);
    	portNames << QString(result);
    }
    return portNames;
}
