#ifndef _CHANNEL_TRANSPORT_H_
#define _CHANNEL_TRANSPORT_H_


#define TRANSPORT_EVENT_WAIT_TIMEOUT 0
#define TRANSPORT_EVENT_CONNECTED 1
#define TRANSPORT_EVENT_DISCONNECTED 2
#define TRANSPORT_EVENT_ACCEPTED 3
#define TRANSPORT_EVENT_MESSAGE_RECIEVED 4
#define TRANSPORT_EVENT_MESSAGE_SENT 5
#define TRANSPORT_EVENT_SYSTEM_ERROR 6
#define TRANSPORT_EVENT_EXIT 7

#define TRANSPORT_EVENT_COUNT 8

typedef int TRANSPORT_EVENT;

#ifdef DWORD
#undef DWORD
#endif

#ifndef VPG_OK
#define VPG_OK 0
#endif
#ifndef VPG_FAIL
#define VPG_FAIL -1
#endif

#define DWORD uint32

#define MAKE_SESSION_ID(x) ((x) ^ 0x80000000)
#define ISREMOTE_ID(x) ( ( (x) & 0x80000000) != 0 )

typedef uint32 session_id;
typedef int  vpg_result;


typedef vpg_result (* transport_event_handler ) ( TRANSPORT_EVENT _event );


typedef struct _channel_session
{
    session_id id;
    
    STREAM recieved;
    STREAM sending;
    
    void ( *channel_session_process ) ( struct _channel_session * _session, TRANSPORT_EVENT _ev );
    
}channel_session;

vpg_result channel_session_create_message ( channel_session * _session, STREAM * _msg , DWORD _size );
vpg_result channel_session_free_message   ( channel_session * _session, STREAM _msg );

vpg_result channel_session_recv_message   ( channel_session * _session, STREAM* _msg );
vpg_result channel_session_send_message   ( channel_session * _session, STREAM _msg );

vpg_result channel_transport_init ( char * _vchannelname , transport_event_handler _event_handler);

vpg_result channel_transport_create_session  ( channel_session ** _session );
vpg_result channel_transport_destroy_session ( channel_session * _session );


#endif
