//
//  pndna_proxy.cpp
//  qrdesktop
//
//  Created by liza on 9/21/12.
//  Copyright 2012 Quest vWorkspace. All rights reserved.
//

#include "pndna_proxy.h"
#include "proxy_utils.h"

#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <limits.h>
#include <stdlib.h>
#include <stdio.h>

pid_t startPNDNAProxy(const char* remotehost, char* localhost, size_t size)
{
    unsigned short startPort = 49152;       
    const unsigned short portsDelta = 100;
    const unsigned short endPort = (startPort < (USHRT_MAX - portsDelta)) ? startPort + portsDelta : USHRT_MAX;
    
    unsigned short port = getFreePort(startPort, endPort);
    snprintf(localhost, size, "127.0.0.1:%d", port);
    
    pid_t pid = fork();
    
    if (pid == 0)
    {        
        //example of command line for pndnaproxy
        //pndnaproxy -L localhost:8000 -R 192.168.99.15:3389 -c -t 3
        
        syslog(LOG_NOTICE, "Starting PNDNA proxy: 'pndnaproxy -L %s -R %s -c -t 3'", localhost, remotehost);
        int execRes = execlp("pndnaproxy", 
                              "pndnaproxy", 
                              "-L", localhost, 
                              "-R", remotehost, 
                              "-c", 
                              "-t", "3", //number of threads was copied from Linux Connector 
                              NULL);
        
        syslog(LOG_NOTICE, "execRes: %d, errno: %d", execRes, errno);
        exit(1);
    }
    
    return pid;
}
