//
//  proxy_utils.cpp
//  qrdesktop
//
//  Created by liza on 9/21/12.
//  Copyright 2012 Quest vWorkspace. All rights reserved.
//

#include "proxy_utils.h"

#include <boost/asio.hpp>

int isPortFree(unsigned short port)
{
    using boost::asio::ip::tcp;
    try
    {
        boost::asio::io_service ioService;
        boost::asio::ip::tcp::acceptor acceptor(ioService);
        boost::asio::ip::tcp::endpoint endpoint(boost::asio::ip::tcp::v4(), port);
        acceptor.open(endpoint.protocol());
        acceptor.set_option(boost::asio::ip::tcp::acceptor::reuse_address(false));
        acceptor.bind(endpoint);
        acceptor.close();
    }
    catch(const boost::system::system_error&)
    {
        return 0;
    }
    return 1;
}

unsigned short getFreePort(unsigned short startPort, unsigned short endPort)
{
    for (unsigned short port = startPort; port <= endPort; ++port)
    {
        if (!isPortFree(port))
        {
            continue;
        }
        return port;
    }
    return 0;
}
