/*
 * wave_buffer.h
 *
 *  Created on: 05.08.2009
 *      Author: beloborodov
 */

#ifndef _WAVE_BUFFER_H_
#define _WAVE_BUFFER_H_

#include <pthread.h>

#define MAX_WAVE_BUFFER_SIZE (4 * 1024 * 1024 ) /* four megabytes */

typedef struct
{
	uint8 * data;
	int size;
	int read_ptr;
	int write_ptr;
	int write_avail;

	pthread_mutex_t sync;
} sync_wave_buffer;

sync_wave_buffer * wave_buffer_create (  int _size );

void wave_buffer_destroy( sync_wave_buffer * _wave );

void wave_buffer_clear ( sync_wave_buffer * _wave );

int wave_buffer_get_size ( sync_wave_buffer * _wave);

int wave_buffer_read ( sync_wave_buffer * _wave , uint8* _data , int _to_read );

int wave_buffer_write ( sync_wave_buffer * _wave , uint8 * _data , int _to_write );

int wave_buffer_get_writed_bytes ( sync_wave_buffer * _wave);


#endif /* WAVE_BUFFER_H_ */
